#!/usr/bin/env gosh

(use povray)
(use povray.colors)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; simple lathe

;   #include "colors.inc"
;   background{White}
;   camera {
;     angle 10
;     location <1, 9, -50>
;     look_at <0, 2, 0>
;   }
;   light_source {
;     <20, 20, -20> color White
;   }
;   lathe {
;     linear_spline
;     6,
;     <0,0>, <1,1>, <3,2>, <2,3>, <2,4>, <0,4>
;     pigment { Blue }
;     finish {
;       ambient .3
;       phong .75
;     }
;   }

; (display
;  (scene
;   (camera (angle 10) (location (point 1 9 -50)) (look-at (point 0 2 0)))
;   (light-source (point 20 20 -20) White)
;   (lathe (linear-spline)
;          '(#(0 0) #(1 1) #(3 2) #(2 3) #(2 4) #(0 4))
;          (pigment Blue)
;          (finish (ambient .3) (phong .75)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; surface of revolution

;   #include "colors.inc"
;   #include "golds.inc"
;   global_settings { assumed_gamma 2.2 }
;   camera {
;     location <10, 15, -20>
;     look_at <0, 5, 0>
;     angle 45
;   }
;   background { color rgb<0.2, 0.4, 0.8>  }
;   light_source { <100, 100, -100> color rgb 1 }
;   plane {
;     y, 0
;     pigment { checker color Red, color Green scale 10 }
;   }
;   sor {
;     8,
;     <0.0,  -0.5>,
;     <3.0,   0.0>,
;     <1.0,   0.2>,
;     <0.5,   0.4>,
;     <0.5,   4.0>,
;     <1.0,   5.0>,
;     <3.0,  10.0>,
;     <4.0,  11.0>
;     open
;     texture { T_Gold_1B }
;   }


(display
 (scene
  (camera (angle 45) (location (point 10 15 -20)) (look-at (point 0 5 0)))
  (background (color 0.2 0.4 0.8))
  (light-source (point 100 100 -100) White)
  (scale 10 (plane y 0 (pigment (checker Red Green))))
  (sor '(#(0 -.5) #(3 0) #(1 .2) #(.5 .4) #(.5 4) #(1 5) #(3 10) #(4 11))
       (open)
       (texture (pigment BrightGold)
                (finish (brilliance 3)
                        ;(diffuse D_GoldB)
                        ;(ambient A_GoldB)
                        (reflection 1)
                        (metallic) ;M
                        (specular 0.30)
                        (roughness 1/60))))))
