#!/usr/bin/env gosh

(use povray)
(use povray.colors)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; basic example - a sphere

;   #include "colors.inc"
;   background { color Cyan }
;   camera {
;     location <0, 2, -3>
;     look_at  <0, 1,  2>
;   }
;   sphere {
;     <0, 1, 2>, 2
;     texture {
;       pigment { color Yellow }
;     }
;   }
;   light_source { <2, 4, -3> color White}

; (display
;  (scene
;   (background Cyan)
;   (camera (location (point 0 2 -3)) (look-at (point 0 1 2)))
;   (sphere (point 0 1 2) 2 (texture (pigment Yellow)))
;   (light-source (point 2 4 -3) White)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; playing with text (you may need to edit the font path)

; (display
;  (scene
;   (camera (location (point -5 .15 -2)) (look-at (point .3 .2 1)) (angle 35))
;   (light-source (point 500 500 -1000) White)
;   (plane y 0 (texture (pigment SeaGreen)
;                       (finish (reflection .35) (specular 1))
;                       (scale .25 (normal (ripples .35) (turbulence .5)))))
;   (translate (* -3 x)
;              (text (ttf "/usr/share/fonts/truetype/freefont/FreeMono.ttf"
;                         "POV-RAY 3.0" 25 (* y 0.1))
;                    (pigment BrightGold)
;                    (finish (reflection .25) (specular 1))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; making a chain from toruses

(let* ((flip-it-over (* x 180))
       (torus-translate 8)
       (link-translate (- (* torus-translate 2) (* y 2)))
       (chain-gold (texture (pigment BrightGold)
                            (finish (ambient .1) (diffuse .4)
                                    (reflection .25) (specular 1)
                                    (metallic))))
       (half-torus (difference (rotate (* x -90) (torus 4 1 (sturm)))
                               (box (point -5 -5 -1) (point 5 0 1))))
       (chain-segment (cylinder (point 0 4 0) (point 0 -4 0) 1))
       (link (union (translate (* y torus-translate 1/2) half-torus)
                    (translate (* y torus-translate -1/2) (rotate flip-it-over half-torus))
                    (translate (* x torus-translate 1/2) chain-segment)
                    (translate (* x torus-translate -1/2) chain-segment)
                    chain-gold))
       (link-pair (union link
                         (rotate (* y 90) (translate (* y link-translate) link))))
       (chain (union link-pair
                     (translate (* y link-translate 2) link-pair)
                     (translate (* y link-translate 4) link-pair)
                     (translate (* y link-translate 6) link-pair)
                     (translate (* y link-translate -2) link-pair)
                     (translate (* y link-translate -4) link-pair)
                     (translate (* y link-translate -6) link-pair))))
  (display
   (scene
    (background Gray50)
    (camera (location (point 0 .1 -25)) (look-at origin) (angle 30))
    (light-source (point 300 300 -1000) White)
    (rotate (point 0 45 -45) (scale 0.1 chain))
    )))
